<template lang="pug">
q-card.q-my-md(flat, bordered)
  q-card-section(horizontal)
    q-card-section.col
      span.material-icons(style="font-size: 36px; color: #027be3") description
      span.vertical-middle.text-h5.vspace1.ellipsis {{ doc.title }}
    q-separator(vertical)
    q-card-actions.justify-around.q-px-md
      q-btn.gdoc-tile-btn(
        :loading="deleteLoading",
        :disabled="isAnonymous",
        flat,
        round,
        type="a",
        v-on:click="removeDocument",
        icon="delete",
        color="grey-6"
      )
        q-tooltip Delete this document
      q-btn.gdoc-tile-btn(
        :disabled="isAnonymous",
        flat,
        round,
        type="a",
        v-on:click="editDocument",
        icon="edit",
        color="grey-6"
      )
        q-tooltip Edit this document
      q-btn.gdoc-tile-btn(
        flat,
        round,
        type="a",
        v-on:click="viewDocument",
        icon="remove_red_eye",
        color="grey-6"
      )
        q-tooltip View this document
      q-btn.gdoc-tile-btn(
        v-if="!configurationMode"
        :loading="distributeLoading",
        flat,
        round,
        type="a",
        v-on:click="distributeDocument",
        icon="message",
        :class="{ disabled: this.doc.distributed || !canDistribute }",
        :color="canDistribute ? `positive` : `negative`"
      )
        q-tooltip {{ canDistribute ? "Copy and distribute to participants" : "ZoomSensors need to be assigned to breakout rooms in the class before documents can be distributed" }}
</template>

<script lang="ts">
import Vue, { PropType } from "vue";
import * as firebase from "firebase";

// These unassigned imports pull in the relevant typescript definitions of these Vue extensions.
import "vue-cookies";
import "quasar";

export default Vue.extend({
  name: "GDocTile",
  props: {
    doc: { type: Object },
    docId: { type: String },
    meetingId: { type: String },
    breakoutRooms: { type: Array as PropType<string[]> },
    canDistribute: { type: Boolean },
    functions: {
      required: true,
      type: Object as PropType<firebase.functions.Functions>,
    },
    configurationMode: {
      type: Boolean,
    },
  },
  data() {
    return {
      distributeLoading: false,
      deleteLoading: false,
    };
  },
  filters: {},
  computed: {
    isAnonymous(): boolean {
      return Boolean(this.$cookies.get("anonymous"));
    },
  },
  methods: {
    viewDocument() {
      window.open(`https://docs.google.com/document/d/${this.docId}`, "_blank");
    },
    async removeDocument() {
      if (this.isAnonymous) return;

      this.deleteLoading = true;

      try {
        const deleteDocument = this.functions.httpsCallable("GDocs-googleDocsDeleteDocument");
        await deleteDocument({
          meetingId: this.meetingId,
          docId: this.docId,
        });
        this.$q.notify({
          type: "positive",
          message: "Document deleted",
        });
        //- window.alert("Document deleted");
        this.deleteLoading = false;
      } catch (error) {
        this.deleteLoading = false;
        this.$q.notify({
          type: "negative",
          message: "There was an error, please try again",
        });
        console.error("Document submission", error);
      }

    },
    editDocument() {
      if (this.isAnonymous) return;

      // TODO confirmation (user will lose any changes manually made to the document)
      this.$emit("set-document-id", this.docId);
    },
    async distributeDocument() {
      if (this.doc.distributed || !this.canDistribute) return;

      this.distributeLoading = true;

      const anonymous = this.$cookies.get("anonymous");

      try {
        const distributeDocs = this.functions.httpsCallable("GDocs-googleDocsDistributeAndStartWatchingCopies");
        await distributeDocs({
          meetingId: this.meetingId,
          documentId: this.docId,
          roomIds: this.breakoutRooms,
          // For anonymous users, pass the hostuid when trying to distribute the docs
          hostId: anonymous?.hostuid,
        });
        this.$q.notify({
          type: "positive",
          message: "Document distributed!",
        });
        this.distributeLoading = false;
      } catch (error) {
        this.$q.notify({
          type: "negative",
          message: "There was an error, please try again.",
        });
        console.error("distribute doc error", error);
        this.distributeLoading = false;
      }
    },
  },
  components: {},
});
</script>

<style scoped>
.gdoc-tile-btn {
  margin-left: 5px;
  margin-right: 5px;
}
</style>